from bge import logic as g, events
scene = g.getCurrentScene()

def move(cont):
    own = cont.owner
    key = g.keyboard.events
    JUST_ACTIVATED = g.KX_INPUT_JUST_ACTIVATED
    gRay = cont.sensors["gRay"]
    if not "moveinit" in own:
        own["speed"] = 5.0
        own["jumpForce"] = 300
        own["accel"] = 3.0
        own["x"] = 0.0
        own["moveinit"] = True
        own["friction"] = 0.75

    own["z"] = own.getLinearVelocity()[2]

    if key[events.LEFTARROWKEY]:
        own["x"] -= own["accel"]

    elif key[events.RIGHTARROWKEY]:
        own["x"] += own["accel"]

    else:
        own["x"] *= own["friction"]
    
    own["x"] = own["speed"] if own["x"] > own["speed"] else -own["speed"] if own["x"] < -own["speed"] else own["x"]
    
    if key[events.ZKEY] == JUST_ACTIVATED and gRay.positive:
        own.applyForce([0, 0, own["jumpForce"]])

    
    if gRay.positive:
        target = cont.sensors["gRay"].hitObject
        own.setLinearVelocity([-own["x"] + target.getLinearVelocity().x, 0.0, own["z"]], True)
    else:
        own.setLinearVelocity([-own["x"], 0.0, own["z"]], True)

def trackToCamera(cont):
    #own = cont.owner
    #own.alignAxisToVect(own.getVectTo(scene.objects["Camera"])[1],1,1)
    cont.activate("trackToCamera")

def depth(cont):
    own = cont.owner
    fRay = cont.sensors["fRay"]
    bRay = cont.sensors["bRay"]

    if fRay.positive:
        target = fRay.hitObject
        targetPos = fRay.hitPosition
        own.worldPosition.x = targetPos[0]
        own.worldPosition.y = targetPos[1]

    elif bRay.positive:
        target = bRay.hitObject
        targetPos = bRay.hitPosition
        own.worldPosition.x = targetPos[0]
        own.worldPosition.y = targetPos[1]

def main(cont):
    own = cont.owner
    trackToCamera(cont)
    move(cont)
    depth(cont)